## karp 0+p24.04+vunstable+git20250915.0223

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 by Tomasz Bojczuk <seelook@gmail.com>
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

# KDE Applications version, managed by release script.
set(RELEASE_SERVICE_VERSION_MAJOR "25")
set(RELEASE_SERVICE_VERSION_MINOR "03")
set(RELEASE_SERVICE_VERSION_MICRO "70")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(karp VERSION ${RELEASE_SERVICE_VERSION})

include(FeatureSummary)

set(QT6_MIN_VERSION 6.8.0)
set(KF6_MIN_VERSION 6.0.0)
set(KIRIGAMI_ADDONS_MIN_VERSION 1.5.0)

find_package(ECM ${KF6_MIN_VERSION} REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(FeatureSummary)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMSetupVersion)
include(ECMFindQmlModule)
include(ECMDeprecationSettings)
include(ECMQtDeclareLoggingCategory)
if (NOT ANDROID)
    include(KDEGitCommitHooks)
    include(KDEClangFormat)
endif()

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX KARP
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/src/version-karp.h"
)

set(QT_EXTRA_COMPONENTS)
if (NOT ANDROID)
    list(APPEND QT_EXTRA_COMPONENTS Widgets)
endif()

find_package(Qt6 ${QT6_MIN_VERSION} REQUIRED COMPONENTS Core Gui Qml QuickControls2 Svg Pdf ${QT_EXTRA_COMPONENTS})

if (QT_KNOWN_POLICY_QTP0004)
    qt_policy(SET QTP0004 NEW)
endif ()

find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS Kirigami CoreAddons Config I18n IconThemes)
find_package(KF6 ${KF6_MIN_VERSION} COMPONENTS Crash)
find_package(KF6KirigamiAddons ${KIRIGAMI_ADDONS_MIN_VERSION})
set_package_properties(KF6KirigamiAddons PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required application components and runtime dependency"
)

ecm_set_disabled_deprecation_versions(QT 6.9.0
    KF 6.16.0
)

find_package(qpdf REQUIRED)

qt_policy(SET QTP0001 NEW)

ecm_find_qmlmodule(org.kde.kirigamiaddons.formcard 1.0)

if (ANDROID)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/android/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()

add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)

add_subdirectory(src)

install(FILES org.kde.karp.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES org.kde.karp.metainfo.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
install(FILES org.kde.karp.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps)
ki18n_install(po)

ecm_qt_install_logging_categories(
    EXPORT KARP
    FILE karp.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

if (NOT ANDROID)
    file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES src/*.cpp src/*.h)
    kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
    kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
endif()

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: 2024 by Tomasz Bojczuk <seelook@gmail.com>

kde_enable_exceptions()

add_executable(karp)

ecm_qt_declare_logging_category(karp
    HEADER karp_debug.h
    IDENTIFIER KARP_LOG
    CATEGORY_NAME org.kde.karp
    DESCRIPTION "karp"
    EXPORT KARP
)

qt_add_qml_module(karp
    URI org.kde.karp
    QML_FILES
        qml/Main.qml
        qml/About.qml
        qml/MainPage.qml
        qml/MainToolbar.qml
        qml/EditDelegate.qml
        qml/PdfView.qml

        qml/Dialogs/SelectPagesDialog.qml
        qml/Dialogs/MovePagesDialog.qml
        qml/Dialogs/PdfMetadataDialog.qml
        qml/Dialogs/PdfFilesDialog.qml
        qml/Dialogs/PdfPassDialog.qml
        qml/Dialogs/PdfFileDelegate.qml

        qml/Settings/SettingsPage.qml
        qml/Settings/PdfTools.qml
        qml/Settings/General.qml
        qml/Settings/FormPathDelegate.qml

        qml/Messages/MissingPdfTool.qml
        qml/Messages/ProgressDialog.qml
        qml/Messages/InitialInfo.qml

        qml/Bookmarks/TOCView.qml
        qml/Bookmarks/OutlineDialog.qml

    DEPENDENCIES
        QtCore
        QtQuick
    IMPORTS
        org.kde.karp.config

)


# Below definition is for qpdf library.
# @see https://qpdf.readthedocs.io/en/stable/design.html#smart-pointers
# For now there is not much use of it in Karp case
target_compile_definitions(karp PRIVATE POINTERHOLDER_TRANSITION=0)

target_sources(karp PUBLIC
    main.cpp
    app.cpp
    pdfpage.cpp
    pdffile.cpp
    pdfmetadata.cpp
    pdfeditmodel.cpp
    pdfpageitem.cpp
    pdfsorganizer.cpp
    toolsthread.cpp
    pagerange.cpp
    qpdfproxy.cpp
    bookmarkmodel.cpp
    outline.cpp

    app.h
    pdfpage.h
    pdffile.h
    pdfmetadata.h
    pdfeditmodel.h
    pdfpageitem.h
    pdfsorganizer.h
    toolsthread.h
    pagerange.h
    qpdfproxy.h
    bookmarkmodel.h
    outline.h
)

target_link_libraries(karp
    PUBLIC
    Qt6::Core
    Qt6::Gui
    Qt6::Qml
    Qt6::Quick
    Qt6::QuickControls2
    Qt6::Svg
    Qt6::Pdf
    KF6::I18n
    KF6::IconThemes
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::Kirigami
    KirigamiAddonsStatefulApp
    qpdf::libqpdf
)

if (TARGET KF6::I18nQml)
    target_link_libraries(karp PUBLIC
        KF6::I18nQml
    )
endif()
if (TARGET KF6::Crash)
    target_link_libraries(karp PUBLIC KF6::Crash)
endif()

target_include_directories(karp PUBLIC ${CMAKE_BINARY_DIR})

if (ANDROID)
    kirigami_package_breeze_icons(ICONS
        list-add
        help-about
        application-exit
        applications-graphics
        # app icon
    )
else()
    target_link_libraries(karp PUBLIC Qt::Widgets)
endif()


if(APPLE)
    set_target_properties(karp PROPERTIES
        MACOSX_BUNDLE_DISPLAY_NAME "Karp"
        MACOSX_BUNDLE_BUNDLE_NAME "Karp"
        MACOSX_BUNDLE_LONG_VERSION_STRING "Karp ${RELEASE_SERVICE_VERSION}"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${RELEASE_SERVICE_VERSION}"
        MACOSX_BUNDLE_BUNDLE_VERSION "${RELEASE_SERVICE_VERSION}"
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.karp"
	MACOSX_BUNDLE_COPYRIGHT "2024-2025 The Karp Developers")
endif()

kconfig_add_kcfg_files(karp GENERATE_MOC karpconfig.kcfgc)

install(TARGETS karp ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

## karp 0+p24.04+vunstable+git20250905.0838

=== debian/changelog ===
karp (0+p24.04+vunstable+git20250905.0838-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 05 Sep 2025 08:38:45 +0000

karp (0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 01 Jan 2025 03:13:01 +0000

=== debian/control ===
Source: karp
Section: kde
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               kf6-kconfig-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-kirigami-addons-dev,
               kf6-kirigami-dev,
               libqpdf-dev,
               pkg-kde-tools-neon,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-svg-dev,
               qt6-webengine-dev
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/graphics/karp
Vcs-Git: https://invent.kde.org/neon/neon-packaging/karp.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/karp
Maintainer: Neon CI <neon@kde.org>

Package: karp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Gives simple UI for PDF files modification.
 With a few mouse strokes user can:
 -   Append more PDF files and merge
 -   Delete, rotate and reorder pages
 -   Reduce PDF file size
 -   Optimize images
 -   View and modify PDF properties
 -   Protect PDF with password

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# SPDX-FileCopyrightText: 2025 Jonathan Riddell <jr@jriddell.org>

%:
	dh $@ --with kf6 --buildsystem kf6

## karp 0+p24.04+vunstable+git20251020.0327

=== debian/changelog ===
karp (0+p24.04+vunstable+git20251020.0327-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 03:27:55 +0000

## karp 0+p24.04+vunstable+git20251114.0708

=== debian/changelog ===
karp (0+p24.04+vunstable+git20251114.0708-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 14 Nov 2025 07:08:48 +0000

## karp 0+p24.04+vunstable+git20251125.1313

=== debian/changelog ===
karp (0+p24.04+vunstable+git20251125.1313-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 25 Nov 2025 13:13:09 +0000

## karp 0+p24.04+vunstable+git20260123.0431

=== debian/changelog ===
karp (0+p24.04+vunstable+git20260123.0431-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 23 Jan 2026 04:31:26 +0000

## karp 0+p24.04+vunstable+git20260201.0649

=== CMakeLists.txt ===
--- 
+++ 
@@ -61,8 +61,8 @@
     PURPOSE "Required application components and runtime dependency"
 )
 
-ecm_set_disabled_deprecation_versions(QT 6.9.0
-    KF 6.16.0
+ecm_set_disabled_deprecation_versions(QT 6.10.0
+    KF 6.19.0
 )
 
 find_package(qpdf REQUIRED)
